# +-----------------------------------------------+
# | UltiRank DB Uprader                           |
# | filename: upgrader.py                         |
# | Created by Ulti - http://thekks.net           |
# | Status: Alpha                                 |
# | Website: http://thekks.net                    |
# | Requirement: EventScript 2.1 or higher        |
# +-----------------------------------------------+
# |                    Credits                    |
# | Design: KKSNetwork                            |
# | Coding: Ultimatebuster                        |
# +-----------------------------------------------+

# should be pyc when published so no one can mess with it.

from_version = 0.1
to_version = 0.1

import shelve

GENERAL_FAILURE = -1
SUCCESS = 0
FROM_VERSION_MISMATCH = 1
TO_VERSION_MISMATCH = 2
DB_ALREADY_UPTODATE = 3

def upgrade(toversion, path):
    if toversion != to_version:
        return TO_VERSION_MISMATCH
    
    db = shelve.open(path, writeback=True)
    if db["version"] != from_version:
        db.close()
        return FROM_VERSION_MISMATCH
    
    if db["version"] == to_version:
        db.close()
        return DB_ALREADY_UPTODATE
    
    returnCode = _performupgrade(db)
    if returnCode == SUCCESS:
        db["version"] = to_version
        db.close()
        return SUCCESS
    else:
        return returnCode

def _performupgrade(db):
    # change this function when need to upgrade in an update
    return SUCCESS
    
